function [config]=leer
%config is a structure formed by
%config.file_input
%config.file_output
%config.comment
%config.track_title
%config.freq_max
%config.freq_min
%config.segment_size
%config.tempo
%config.channel
%config.time_signature
%config.instrument
%config.percent_silen
%config.autocor
%config.center_clip_percen
%config.analysis_method
%config.num_lpc



fid=fopen('config.pbg','rb');
y=fread(fid);
fclose(fid);
y=(setstr(y))';


config.file_input=busca_tags('FILE_INPUT',y);
config.file_output=busca_tags('FILE_OUTPUT',y);
[signal,Fs,bits]=wavread(config.file_input);


config.ticks_negra=str2num(busca_tags('TICKS_NEGRA',y));
config.track_title=busca_tags('TRACK_TITLE',y);
config.comment=busca_tags('COMMENT',y);
config.time_signature=str2num(busca_tags('TIME_SIGNATURE',y));
config.tempo=str2num(busca_tags('TEMPO',y));
config.channel=str2num(busca_tags('CHANNEL',y))-1;	%en midi se habla de los canales 1-16 y se escribe 0-15
config.instrument=str2num(busca_tags('INSTRUMENT',y))-1;
config.segment_size=str2num(busca_tags('SEGMENT_SIZE',y));
config.advance=str2num(busca_tags('ADVANCE',y));
config.percen_silen=str2num(busca_tags('PERCENT_SILEN',y));
config.analysis_method=str2num(busca_tags('ANALYSIS_METHOD',y));
config.freq_max=str2num(busca_tags('FREQ_MAX',y));
config.freq_min=str2num(busca_tags('FREQ_MIN',y));
config.num_lpc=str2num(busca_tags('NUM_LPC',y));
config.percen_autocor=str2num(busca_tags('PERCEN_AUTOCOR',y));
config.center_clip_percen=str2num(busca_tags('CENTER_CLIP_PERCEN',y));
endfunction