function [delta]=set_delta(ticks)
%dado un numero de ticks transcurriods desde el ultimo evento MIDI
%devuelve el vector de longitud 1,2,3,  4 segun el valorde este ltimo

%fprintf ('Voy a calcular el delta-time basandome en los ticks que me han llegado')
ticks=round(ticks);
if ticks<128
   %1 solo byte
   delta=ticks;
elseif ticks<128^2
   %2 bytes
   delta(1,1)=floor(ticks/128)+128;
   delta(1,2)=rem(ticks,128);
elseif ticks<128^3
   %3 bytes
   delta(1,3)=rem(ticks,128);
	delta(1,2)=rem((floor(ticks/128)),128)+128;
	delta(1,1)=floor((floor(ticks/128))/128)+128;
elseif ticks<128^4
   %4 bytes
   delta(1,4)=rem(ticks,128);
	delta(1,3)=rem((floor(ticks/128)),128)+128;
	delta(1,2)=rem(floor((floor(ticks/128))/128),128)+128;
	delta(1,1)=floor(((floor(ticks/128))/128)/128)+128;

else 
   %silencio demasiado largo
   delta=0;
end
delta;
%pause;